package sun.management.counter.perf;

import java.io.ObjectStreamException;
import sun.management.counter.Variability;
import sun.management.counter.Units;
import java.nio.ByteBuffer;
import sun.management.counter.ByteArrayCounter;
import sun.management.counter.AbstractCounter;

public class PerfByteArrayCounter extends AbstractCounter implements ByteArrayCounter
{
    ByteBuffer bb;
    private static final long serialVersionUID = 2545474036937279921L;
    
    PerfByteArrayCounter(String name, Units units, Variability variability, int flags, int vectorLength, ByteBuffer bb) {
        super(name, units, variability, flags, vectorLength);
        this.bb = bb;
    }
    
    @Override
    public Object getValue() {
        return this.byteArrayValue();
    }
    
    @Override
    public byte[] byteArrayValue() {
        this.bb.position(0);
        byte[] dst = new byte[this.bb.limit()];
        this.bb.get(dst);
        return dst;
    }
    
    @Override
    public byte byteAt(int n) {
        this.bb.position(n);
        return this.bb.get();
    }
    
    @Override
    public String toString() {
        String string = this.getName() + ": " + new String(this.byteArrayValue()) + " " + this.getUnits();
        if (this.isInternal()) {
            return string + " [INTERNAL]";
        }
        return string;
    }
    
    protected Object writeReplace() throws ObjectStreamException {
        return new ByteArrayCounterSnapshot(this.getName(), this.getUnits(), this.getVariability(), this.getFlags(), this.getVectorLength(), this.byteArrayValue());
    }
}
